/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.stimmeingabe.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.ByGebiet",
     query="DELETE FROM Ergebniseingang o WHERE o.wahldurchfuehrungsgebiet = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.ByWahl",
     query="DELETE FROM Ergebniseingang o WHERE EXISTS (SELECT g FROM Wahldurchfuehrungsgebiet g WHERE o.wahldurchfuehrungsgebiet = g AND g.wahl=?1)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.CountErgebnissequenznummerIsNullByWahlEingangsArt",
     query="SELECT COUNT(o) FROM Ergebniseingang o WHERE o.ergebnissequenznummer IS NULL AND o.wahldurchfuehrungsgebiet.wahl = ?1 AND o.ergebniseingangsart = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.CountErgebnissequenznummerIsNull",
     query="SELECT COUNT(o) FROM Ergebniseingang o WHERE o.ergebnissequenznummer IS NulL",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.CountGebiet",
     query="SELECT COUNT(o) FROM Ergebniseingang o WHERE o.wahldurchfuehrungsgebiet = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.CountWahl",
     query="SELECT COUNT(o) FROM Ergebniseingang o WHERE o.wahldurchfuehrungsgebiet.wahl = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.EingeflossenInErgebnis",
     query="SELECT ee FROM Ergebniseingang ee WHERE EXISTS (SELECT ege FROM ErgebnisGueltigerEingang ege WHERE ege.ergebniseingang = ee AND ege.ergebnis = ?1)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.ErgebnissequenznummerIsNull",
     query="SELECT o FROM Ergebniseingang o WHERE o.ergebnissequenznummer IS NulL",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.GebietAndErgebniseingangsartAndErgebniseingangstufe",
     query="SELECT e FROM Ergebniseingang e WHERE e.wahldurchfuehrungsgebiet = ?1 AND e.ergebniseingangsart = ?2 AND e.ergebniseingabestufe IN(?3)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.GebietUndErgebniseingangsart",
     query="SELECT e FROM Ergebniseingang e WHERE e.wahldurchfuehrungsgebiet = ?1 AND e.ergebniseingangsart = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.MaxEingangssequenznummerByWahlEingangsArt",
     query="SELECT MAX(e.eingangssequenznummer) FROM Ergebniseingang e WHERE e.wahldurchfuehrungsgebiet.wahl = ?1 AND e.ergebniseingangsart = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.MaxEingangssequenznummer",
     query="SELECT MAX(e.eingangssequenznummer) FROM Ergebniseingang e",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.MaxErgebnissequenznummerByWahlUndErgebniseingangsart",
     query="SELECT MAX(e.ergebnissequenznummer) FROM Ergebniseingang e WHERE e.wahldurchfuehrungsgebiet.wahl = ?1 AND e.ergebniseingangsart = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.MaxErgebnissequenznummer",
     query="SELECT MAX(e.ergebnissequenznummer) FROM Ergebniseingang e",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.NeuesteEingaengeByWahlAndErgebniseingangsartAndErgebniseingabestufeDbms",
     query="SELECT e FROM Ergebniseingang e WHERE e.wahldurchfuehrungsgebiet.wahl = ?1 AND e.ergebniseingangsart = ?2 AND e.ergebniseingabestufe IN(?3) AND (e.wahldurchfuehrungsgebiet, e.eingangssequenznummer) IN (SELECT e2.wahldurchfuehrungsgebiet, MAX(e2.eingangssequenznummer) FROM Ergebniseingang e2 WHERE e2.wahldurchfuehrungsgebiet.wahl = ?1 AND e2.ergebniseingangsart = ?2 AND e2.ergebniseingabestufe IN(?3) GROUP BY e2.wahldurchfuehrungsgebiet)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.NeuesteEingaengeByWahlAndErgebniseingangsartAndErgebniseingabestufeH2",
     query="SELECT e FROM Ergebniseingang e WHERE e.wahldurchfuehrungsgebiet.wahl = ?1 AND e.ergebniseingangsart = ?2 AND e.ergebniseingabestufe IN(?3) AND e.eingangssequenznummer IN (SELECT MAX(e2.eingangssequenznummer) FROM Ergebniseingang e2 WHERE e2.wahldurchfuehrungsgebiet.wahl = ?1 AND e2.ergebniseingangsart = ?2 AND e2.ergebniseingabestufe IN(?3) GROUP BY e2.wahldurchfuehrungsgebiet)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.NeuesteEingaengeByWahlAndErgebniseingangsartDbms",
     query="SELECT e FROM Ergebniseingang e WHERE e.wahldurchfuehrungsgebiet.wahl = ?1 AND e.ergebniseingangsart = ?2 AND (e.wahldurchfuehrungsgebiet, e.eingangssequenznummer) IN (SELECT e2.wahldurchfuehrungsgebiet, MAX(e2.eingangssequenznummer) FROM Ergebniseingang e2 WHERE e2.wahldurchfuehrungsgebiet.wahl = ?1 AND e2.ergebniseingangsart = ?2 GROUP BY e2.wahldurchfuehrungsgebiet)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.NeuesteEingaengeByWahlAndErgebniseingangsartH2",
     query="SELECT e FROM Ergebniseingang e WHERE e.wahldurchfuehrungsgebiet.wahl = ?1 AND e.ergebniseingangsart = ?2 AND e.eingangssequenznummer IN (SELECT MAX(e2.eingangssequenznummer) FROM Ergebniseingang e2 WHERE e2.wahldurchfuehrungsgebiet.wahl = ?1 AND e2.ergebniseingangsart = ?2 GROUP BY e2.wahldurchfuehrungsgebiet)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.NeuesterEingangByGebietAndErgebniseingangsartAndErgebniseingabestufe",
     query="SELECT e FROM Ergebniseingang e WHERE e.eingangssequenznummer = ( SELECT MAX(e2.eingangssequenznummer) FROM Ergebniseingang e2 WHERE e2.wahldurchfuehrungsgebiet = ?1 AND e2.ergebniseingangsart IN(?2) AND e2.ergebniseingabestufe IN(?3))",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.NeuesterEingangByGebietAndErgebniseingangsartAndFehlerstatusAndErgebniseingabestufe",
     query="SELECT e FROM Ergebniseingang e WHERE e.eingangssequenznummer = ( SELECT MAX(e2.eingangssequenznummer) FROM Ergebniseingang e2 WHERE e2.wahldurchfuehrungsgebiet = ?1 AND e2.ergebniseingangsart IN (?2) AND e2.ergebniseingangsfehlerstatus IN (?3) AND e2.ergebniseingabestufe IN(?4))",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.NeuesterEingangByGebietAndErgebniseingangsartAndFehlerstatus",
     query="SELECT e FROM Ergebniseingang e WHERE e.eingangssequenznummer = ( SELECT MAX(e2.eingangssequenznummer) FROM Ergebniseingang e2 WHERE e2.wahldurchfuehrungsgebiet = ?1 AND e2.ergebniseingangsart IN (?2) AND e2.ergebniseingangsfehlerstatus IN (?3))",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.NeuesterEingangByGebietAndErgebniseingangsart",
     query="SELECT e FROM Ergebniseingang e WHERE e.eingangssequenznummer = ( SELECT MAX(e2.eingangssequenznummer) FROM Ergebniseingang e2 WHERE e2.wahldurchfuehrungsgebiet = ?1 AND e2.ergebniseingangsart IN(?2))",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.WahlArtenStatusErgebnissequenznummerZwischen",
     query="SELECT e FROM Ergebniseingang e WHERE e.wahldurchfuehrungsgebiet.wahl = ?1 AND e.ergebniseingangsart = ?2 AND e.ergebniseingangsfehlerstatus IN(?3) AND e.ergebnissequenznummer <= ?4 AND e.ergebnissequenznummer>=?5 AND e.ergebnissequenznummer = ( SELECT MAX(e2.ergebnissequenznummer) FROM Ergebniseingang e2 WHERE e2.wahldurchfuehrungsgebiet = e.wahldurchfuehrungsgebiet AND e2.ergebniseingangsart = ?2 AND e2.ergebniseingangsfehlerstatus IN(?3) AND e2.ergebnissequenznummer <= ?4 AND e2.ergebnissequenznummer>=?5)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.WahlFehlerstatusUndErgebnissequenznummerZwischen",
     query="SELECT e FROM Ergebniseingang e WHERE e.ergebnissequenznummer <= ?3 AND e.ergebnissequenznummer>=?4 AND e.wahldurchfuehrungsgebiet.wahl = ?1 AND e.ergebniseingangsfehlerstatus IN ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNISEINGANG.Wahl",
     query="SELECT e FROM Ergebniseingang e WHERE e.wahldurchfuehrungsgebiet.wahl = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "ERGEBNISEINGANG")
// @javax.persistence.IdClass(ErgebniseingangPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Ergebniseingang
extends AbstractErgebniseingang
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Ergebniseingang() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Ergebniseingang(Ergebniseingang original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "ergebniseingang_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Ergebniseingang")
    @javax.persistence.TableGenerator(name = "Ergebniseingang", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Ergebniseingang", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient ErgebniseingangPK pkCache;

  @Override
  public ErgebniseingangPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new ErgebniseingangPK(getId());
    }

    return pkCache;
  }

  public static <E extends Ergebniseingang> java.util.Map<ErgebniseingangPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<ErgebniseingangPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Ergebniseingang> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedEingabeHashCode = false;
          hasChangedEingangssequenznummer = false;
          hasChangedErfasser = false;
          hasChangedErgebniseingabestufe = false;
          hasChangedErgebniseingangsart = false;
          hasChangedErgebniseingangsfehlerstatus = false;
          hasChangedErgebniseingangsherkunft = false;
          hasChangedErgebnissequenznummer = false;
          hasChangedZeitstempel = false;
  
      hasChangedWahldurchfuehrungsgebiet = false;
  

                  hasChangedStimmeingabesByErgebniseingang = false;
      
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "EINGABE_HASH_CODE", nullable = ErgebniseingangConstants.EINGABE_HASH_CODE_NULLABLE, length=ErgebniseingangConstants.EINGABE_HASH_CODE_MAX_LENGTH)
        
  protected java.lang.String eingabeHashCode =  null;

  @javax.persistence.Transient
  protected boolean hasChangedEingabeHashCode = false;

  public boolean hasChangedEingabeHashCode(){
    return hasChangedEingabeHashCode;
  }
  
  /**
   * 
   *
   * getter for ERGEBNISEINGANG.EINGABE_HASH_CODE
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getEingabeHashCode() {
        return eingabeHashCode;
      }

  /**
   * 
   *
   * setter for ERGEBNISEINGANG.EINGABE_HASH_CODE
   *
   * @param eingabeHashCode
   */
  @Override   public void setEingabeHashCode(@javax.annotation.Nullable  java.lang.String eingabeHashCode) {

       resetTkCache();
                  
                          java.lang.String eingabeHashCodeInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(eingabeHashCode, ErgebniseingangConstants.EINGABE_HASH_CODE_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.eingabeHashCode
      , eingabeHashCodeInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedEingabeHashCode |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("eingabeHashCode");
      }


      

       this.eingabeHashCode = eingabeHashCodeInternal;

         }

        
      @javax.persistence.Column(name = "EINGANGSSEQUENZNUMMER", nullable = ErgebniseingangConstants.EINGANGSSEQUENZNUMMER_NULLABLE, precision=ErgebniseingangConstants.EINGANGSSEQUENZNUMMER_PRECISION, scale=ErgebniseingangConstants.EINGANGSSEQUENZNUMMER_SCALE)
            
  protected java.lang.Long eingangssequenznummer =  null;

  @javax.persistence.Transient
  protected boolean hasChangedEingangssequenznummer = false;

  public boolean hasChangedEingangssequenznummer(){
    return hasChangedEingangssequenznummer;
  }
  
  /**
   * 
   *
   * getter for ERGEBNISEINGANG.EINGANGSSEQUENZNUMMER
   */
    @Override   public  java.lang.Long getEingangssequenznummer() {
        return eingangssequenznummer;
      }

  /**
   * 
   *
   * setter for ERGEBNISEINGANG.EINGANGSSEQUENZNUMMER
   *
   * @param eingangssequenznummer
   */
  @Override   public void setEingangssequenznummer( java.lang.Long eingangssequenznummer) {

       resetTkCache();
                  java.lang.Long eingangssequenznummerInternal = eingangssequenznummer;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.eingangssequenznummer
      , eingangssequenznummerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedEingangssequenznummer |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("eingangssequenznummer");
      }


      

       this.eingangssequenznummer = eingangssequenznummerInternal;

         }

        
      @javax.persistence.Column(name = "ERFASSER", nullable = ErgebniseingangConstants.ERFASSER_NULLABLE, length=ErgebniseingangConstants.ERFASSER_MAX_LENGTH)
        
  protected java.lang.String erfasser =  null;

  @javax.persistence.Transient
  protected boolean hasChangedErfasser = false;

  public boolean hasChangedErfasser(){
    return hasChangedErfasser;
  }
  
  /**
   * 
   *
   * getter for ERGEBNISEINGANG.ERFASSER
   */
    @Override   public  java.lang.String getErfasser() {
        return erfasser;
      }

  /**
   * 
   *
   * setter for ERGEBNISEINGANG.ERFASSER
   *
   * @param erfasser
   */
  @Override   public void setErfasser( java.lang.String erfasser) {

       resetTkCache();
                  
                          java.lang.String erfasserInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(erfasser, ErgebniseingangConstants.ERFASSER_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.erfasser
      , erfasserInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErfasser |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("erfasser");
      }


      

       this.erfasser = erfasserInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "ERGEBNISEINGABESTUFE", nullable = ErgebniseingangConstants.ERGEBNISEINGABESTUFE_NULLABLE)
    
  protected de.ivu.elect.business.stimmeingabe.entity.Ergebniseingabestufe ergebniseingabestufe =  de.ivu.elect.business.stimmeingabe.entity.Ergebniseingabestufe.ENDSTUFE;

  @javax.persistence.Transient
  protected boolean hasChangedErgebniseingabestufe = false;

  public boolean hasChangedErgebniseingabestufe(){
    return hasChangedErgebniseingabestufe;
  }
  
  /**
   * 
   *
   * getter for ERGEBNISEINGANG.ERGEBNISEINGABESTUFE
   */
    @Override   public  de.ivu.elect.business.stimmeingabe.entity.Ergebniseingabestufe getErgebniseingabestufe() {
        return ergebniseingabestufe;
      }

  /**
   * 
   *
   * setter for ERGEBNISEINGANG.ERGEBNISEINGABESTUFE
   *
   * @param ergebniseingabestufe
   */
  @Override   public void setErgebniseingabestufe( de.ivu.elect.business.stimmeingabe.entity.Ergebniseingabestufe ergebniseingabestufe) {

       resetTkCache();
                  de.ivu.elect.business.stimmeingabe.entity.Ergebniseingabestufe ergebniseingabestufeInternal = ergebniseingabestufe;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebniseingabestufe
      , ergebniseingabestufeInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErgebniseingabestufe |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ergebniseingabestufe");
      }


      

       this.ergebniseingabestufe = ergebniseingabestufeInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "ERGEBNISEINGANGSART", nullable = ErgebniseingangConstants.ERGEBNISEINGANGSART_NULLABLE)
    
  protected de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart ergebniseingangsart =  null;

  @javax.persistence.Transient
  protected boolean hasChangedErgebniseingangsart = false;

  public boolean hasChangedErgebniseingangsart(){
    return hasChangedErgebniseingangsart;
  }
  
  /**
   * 
   *
   * getter for ERGEBNISEINGANG.ERGEBNISEINGANGSART
   */
    @Override   public  de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart getErgebniseingangsart() {
        return ergebniseingangsart;
      }

  /**
   * 
   *
   * setter for ERGEBNISEINGANG.ERGEBNISEINGANGSART
   *
   * @param ergebniseingangsart
   */
  @Override   public void setErgebniseingangsart( de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart ergebniseingangsart) {

       resetTkCache();
                  de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart ergebniseingangsartInternal = ergebniseingangsart;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebniseingangsart
      , ergebniseingangsartInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErgebniseingangsart |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ergebniseingangsart");
      }


      

       this.ergebniseingangsart = ergebniseingangsartInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "ERGEBNISEINGANGSFEHLERSTATUS", nullable = ErgebniseingangConstants.ERGEBNISEINGANGSFEHLERSTATUS_NULLABLE)
    
  protected de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsfehlerstatus ergebniseingangsfehlerstatus =  null;

  @javax.persistence.Transient
  protected boolean hasChangedErgebniseingangsfehlerstatus = false;

  public boolean hasChangedErgebniseingangsfehlerstatus(){
    return hasChangedErgebniseingangsfehlerstatus;
  }
  
  /**
   * 
   *
   * getter for ERGEBNISEINGANG.ERGEBNISEINGANGSFEHLERSTATUS
   */
    @Override   public  de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsfehlerstatus getErgebniseingangsfehlerstatus() {
        return ergebniseingangsfehlerstatus;
      }

  /**
   * 
   *
   * setter for ERGEBNISEINGANG.ERGEBNISEINGANGSFEHLERSTATUS
   *
   * @param ergebniseingangsfehlerstatus
   */
  @Override   public void setErgebniseingangsfehlerstatus( de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsfehlerstatus ergebniseingangsfehlerstatus) {

       resetTkCache();
                  de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsfehlerstatus ergebniseingangsfehlerstatusInternal = ergebniseingangsfehlerstatus;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebniseingangsfehlerstatus
      , ergebniseingangsfehlerstatusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErgebniseingangsfehlerstatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ergebniseingangsfehlerstatus");
      }


      

       this.ergebniseingangsfehlerstatus = ergebniseingangsfehlerstatusInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "ERGEBNISEINGANGSHERKUNFT", nullable = ErgebniseingangConstants.ERGEBNISEINGANGSHERKUNFT_NULLABLE)
    
  protected de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsherkunft ergebniseingangsherkunft =  null;

  @javax.persistence.Transient
  protected boolean hasChangedErgebniseingangsherkunft = false;

  public boolean hasChangedErgebniseingangsherkunft(){
    return hasChangedErgebniseingangsherkunft;
  }
  
  /**
   * 
   *
   * getter for ERGEBNISEINGANG.ERGEBNISEINGANGSHERKUNFT
   */
    @Override   public  de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsherkunft getErgebniseingangsherkunft() {
        return ergebniseingangsherkunft;
      }

  /**
   * 
   *
   * setter for ERGEBNISEINGANG.ERGEBNISEINGANGSHERKUNFT
   *
   * @param ergebniseingangsherkunft
   */
  @Override   public void setErgebniseingangsherkunft( de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsherkunft ergebniseingangsherkunft) {

       resetTkCache();
                  de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsherkunft ergebniseingangsherkunftInternal = ergebniseingangsherkunft;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebniseingangsherkunft
      , ergebniseingangsherkunftInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErgebniseingangsherkunft |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ergebniseingangsherkunft");
      }


      

       this.ergebniseingangsherkunft = ergebniseingangsherkunftInternal;

         }

        
  @javax.persistence.Column(name = "ERGEBNISSEQUENZNUMMER", nullable = ErgebniseingangConstants.ERGEBNISSEQUENZNUMMER_NULLABLE, precision=ErgebniseingangConstants.ERGEBNISSEQUENZNUMMER_PRECISION, scale=ErgebniseingangConstants.ERGEBNISSEQUENZNUMMER_SCALE)
            
  protected java.lang.Long ergebnissequenznummer =  null;

  @javax.persistence.Transient
  protected boolean hasChangedErgebnissequenznummer = false;

  public boolean hasChangedErgebnissequenznummer(){
    return hasChangedErgebnissequenznummer;
  }
  
  /**
   * 
   *
   * getter for ERGEBNISEINGANG.ERGEBNISSEQUENZNUMMER
   */
  @javax.annotation.Nullable   @Override   public  java.lang.Long getErgebnissequenznummer() {
        return ergebnissequenznummer;
      }

  /**
   * 
   *
   * setter for ERGEBNISEINGANG.ERGEBNISSEQUENZNUMMER
   *
   * @param ergebnissequenznummer
   */
  @Override   public void setErgebnissequenznummer(@javax.annotation.Nullable  java.lang.Long ergebnissequenznummer) {

       resetTkCache();
                  java.lang.Long ergebnissequenznummerInternal = ergebnissequenznummer;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebnissequenznummer
      , ergebnissequenznummerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErgebnissequenznummer |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ergebnissequenznummer");
      }


      

       this.ergebnissequenznummer = ergebnissequenznummerInternal;

         }

        
      @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "ZEITSTEMPEL", nullable = ErgebniseingangConstants.ZEITSTEMPEL_NULLABLE, precision=ErgebniseingangConstants.ZEITSTEMPEL_PRECISION)
    
  protected java.util.Date zeitstempel =  null;

  @javax.persistence.Transient
  protected boolean hasChangedZeitstempel = false;

  public boolean hasChangedZeitstempel(){
    return hasChangedZeitstempel;
  }
  
  /**
   * 
   *
   * getter for ERGEBNISEINGANG.ZEITSTEMPEL
   */
    @Override   public  java.util.Date getZeitstempel() {
              if (zeitstempel == null){
            return null;
          } else {
                          return zeitstempel;
          }
      }

  /**
   * 
   *
   * setter for ERGEBNISEINGANG.ZEITSTEMPEL
   *
   * @param zeitstempel
   */
  @Override   public void setZeitstempel( java.util.Date zeitstempel) {

       resetTkCache();
                  java.util.Date zeitstempelInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(zeitstempel);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.zeitstempel
      , zeitstempelInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedZeitstempel |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("zeitstempel");
      }


      

       this.zeitstempel = zeitstempelInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Wahldurchfuehrungsgebiet
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHLDURCHFUEHRUNGSGEBIET_ID", referencedColumnName="GEBIET_ID"))
  protected de.ivu.elect.business.gebietsbaum.entity.Wahldurchfuehrungsgebiet wahldurchfuehrungsgebiet;

  /**
   * 
   */
  @Override
  public void setWahldurchfuehrungsgebiet( de.ivu.elect.business.gebietsbaum.entity.Wahldurchfuehrungsgebiet wahldurchfuehrungsgebiet){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahldurchfuehrungsgebiet
    , wahldurchfuehrungsgebiet);

    attributeChanged |= thisAttributChanged;

    hasChangedWahldurchfuehrungsgebiet |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahldurchfuehrungsgebiet");
    }

    this.wahldurchfuehrungsgebiet = wahldurchfuehrungsgebiet;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.gebietsbaum.entity.Wahldurchfuehrungsgebiet getWahldurchfuehrungsgebiet(){
    return this.wahldurchfuehrungsgebiet;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahldurchfuehrungsgebiet = false;

  public boolean hasChangedWahldurchfuehrungsgebiet(){
    return hasChangedWahldurchfuehrungsgebiet;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehung 1:N (bidirektional) zu StimmeingabesByErgebniseingang
   *
   */
  @javax.persistence.OneToMany(targetEntity=de.ivu.elect.business.stimmeingabe.entity.Stimmeingabe.class, mappedBy="ergebniseingang", fetch=javax.persistence.FetchType.LAZY )
// deaktiviert, gibt Probleme beim Löschen  @org.hibernate.annotations.Cache(usage = org.hibernate.annotations.CacheConcurrencyStrategy.TRANSACTIONAL)
  protected java.util.Set<de.ivu.elect.business.stimmeingabe.entity.Stimmeingabe> stimmeingabesByErgebniseingang;


  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  
  @Override
  public java.util.Set<de.ivu.elect.business.stimmeingabe.entity.Stimmeingabe> getStimmeingabesByErgebniseingang(){
    if (stimmeingabesByErgebniseingang == null){
      return  java.util.Collections.<de.ivu.elect.business.stimmeingabe.entity.Stimmeingabe>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.stimmeingabe.entity.Stimmeingabe>emptySet());
    }

    return java.util.Collections.<de.ivu.elect.business.stimmeingabe.entity.Stimmeingabe>unmodifiableSet(this.stimmeingabesByErgebniseingang);
  }

  @javax.persistence.Transient
  private boolean hasChangedStimmeingabesByErgebniseingang = false;

  public boolean hasChangedStimmeingabesByErgebniseingang() {
    return hasChangedStimmeingabesByErgebniseingang;
  }

  /**
   * Hinzufuegen von de.ivu.elect.business.stimmeingabe.entity.Stimmeingabe
   */
  @Override
  public void addStimmeingabeByErgebniseingang(de.ivu.elect.business.stimmeingabe.entity.Stimmeingabe stimmeingabeByErgebniseingang){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (stimmeingabeByErgebniseingang != null){
          if (this.stimmeingabesByErgebniseingang == null) {
            this.stimmeingabesByErgebniseingang = new java.util.HashSet<>();
          }

          boolean isChanged = this.stimmeingabesByErgebniseingang.add(stimmeingabeByErgebniseingang);

          if(!hasChangedStimmeingabesByErgebniseingang) {
            hasChangedStimmeingabesByErgebniseingang =  isChanged;
          }

          // andere Seite der Beziehung aktualisieren
          stimmeingabeByErgebniseingang.setErgebniseingang(this);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.stimmeingabe.entity.Stimmeingabe
   */
  @Override
  public void removeStimmeingabeByErgebniseingang(de.ivu.elect.business.stimmeingabe.entity.Stimmeingabe stimmeingabeByErgebniseingang){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (stimmeingabeByErgebniseingang != null){
          if (this.stimmeingabesByErgebniseingang != null) {
            boolean isChanged = this.stimmeingabesByErgebniseingang.remove(stimmeingabeByErgebniseingang);

            if(!hasChangedStimmeingabesByErgebniseingang) {
              hasChangedStimmeingabesByErgebniseingang =  isChanged;
            }
          }

          // andere Seite der Beziehung aktualisieren
          stimmeingabeByErgebniseingang.setErgebniseingang(null);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen de.ivu.elect.business.stimmeingabe.entity.Stimmeingabe
  */
   @Override
   public void removeAllStimmeingabeByErgebniseingangs(){
     java.util.Set<de.ivu.elect.business.stimmeingabe.entity.Stimmeingabe> toRemove = new java.util.HashSet<>(getStimmeingabesByErgebniseingang());

     for (   de.ivu.elect.business.stimmeingabe.entity.Stimmeingabe entity:toRemove){
       removeStimmeingabeByErgebniseingang(entity);
     }
   }

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Ergebniseingang:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Ergebniseingang other){
                             other.eingabeHashCode = this.eingabeHashCode;
                                other.eingangssequenznummer = this.eingangssequenznummer;
                                other.erfasser = this.erfasser;
                                other.ergebniseingabestufe = this.ergebniseingabestufe;
                                other.ergebniseingangsart = this.ergebniseingangsart;
                                other.ergebniseingangsfehlerstatus = this.ergebniseingangsfehlerstatus;
                                other.ergebniseingangsherkunft = this.ergebniseingangsherkunft;
                                other.ergebnissequenznummer = this.ergebnissequenznummer;
                                other.zeitstempel = this.zeitstempel;
           
  other.setWahldurchfuehrungsgebiet(this.getWahldurchfuehrungsgebiet());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Ergebniseingang.class)){
        copyEntityAttributesUsingSetter((Ergebniseingang) other.castTo(Ergebniseingang.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Ergebniseingang: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Ergebniseingang other){
               other.setEingabeHashCode(this.eingabeHashCode);
                  other.setEingangssequenznummer(this.eingangssequenznummer);
                  other.setErfasser(this.erfasser);
                  other.setErgebniseingabestufe(this.ergebniseingabestufe);
                  other.setErgebniseingangsart(this.ergebniseingangsart);
                  other.setErgebniseingangsfehlerstatus(this.ergebniseingangsfehlerstatus);
                  other.setErgebniseingangsherkunft(this.ergebniseingangsherkunft);
                  other.setErgebnissequenznummer(this.ergebnissequenznummer);
                  other.setZeitstempel(this.zeitstempel);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Ergebniseingang other){
                       if (hasChangedEingabeHashCode) {
        other.setEingabeHashCode(this.eingabeHashCode);
      }
                             if (hasChangedEingangssequenznummer) {
        other.setEingangssequenznummer(this.eingangssequenznummer);
      }
                             if (hasChangedErfasser) {
        other.setErfasser(this.erfasser);
      }
                             if (hasChangedErgebniseingabestufe) {
        other.setErgebniseingabestufe(this.ergebniseingabestufe);
      }
                             if (hasChangedErgebniseingangsart) {
        other.setErgebniseingangsart(this.ergebniseingangsart);
      }
                             if (hasChangedErgebniseingangsfehlerstatus) {
        other.setErgebniseingangsfehlerstatus(this.ergebniseingangsfehlerstatus);
      }
                             if (hasChangedErgebniseingangsherkunft) {
        other.setErgebniseingangsherkunft(this.ergebniseingangsherkunft);
      }
                             if (hasChangedErgebnissequenznummer) {
        other.setErgebnissequenznummer(this.ergebnissequenznummer);
      }
                             if (hasChangedZeitstempel) {
        other.setZeitstempel(this.zeitstempel);
      }
             }





    @javax.persistence.Transient
    private transient ErgebniseingangTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public ErgebniseingangTK getErgebniseingangTK(){
    if (tkCache==null) {
    tkCache = new ErgebniseingangTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getErgebniseingangTK();
    }

  @Override
  public ErgebniseingangUK getUk(){
    return getErgebniseingangUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Ergebniseingang.class;
  }

public ErgebniseingangUK getErgebniseingangUK(){

   return  new ErgebniseingangUK(



  );
}

  @javax.persistence.Transient
  private transient ErgebniseingangProperties properties;

  public ErgebniseingangProperties getProperties(){
    if (properties == null) {
      properties = new ErgebniseingangProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public ErgebniseingangProperties getErgebniseingangProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return ErgebniseingangConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return false;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
                                                                                 }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                                                                                                                                                                                                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                                                                                                                                                               }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "ERGEBNISEINGANG";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Ergebniseingang";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(ErgebniseingangConstants.EINGABE_HASH_CODE_MAX_LENGTH ,  eingabeHashCode, this, ErgebniseingangConstants.MESSAGE_KEY_EINGABE_HASH_CODE_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(eingangssequenznummer, this, ErgebniseingangConstants.MESSAGE_KEY_EINGANGSSEQUENZNUMMER_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(ErgebniseingangConstants.EINGANGSSEQUENZNUMMER_MAX_VALUE, ErgebniseingangConstants.EINGANGSSEQUENZNUMMER_MIN_VALUE, eingangssequenznummer, this, ErgebniseingangConstants.MESSAGE_KEY_EINGANGSSEQUENZNUMMER_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(erfasser, this, ErgebniseingangConstants.MESSAGE_KEY_ERFASSER_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(ErgebniseingangConstants.ERFASSER_MAX_LENGTH , 1 ,  erfasser, this, ErgebniseingangConstants.MESSAGE_KEY_ERFASSER_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(ergebniseingabestufe, this, ErgebniseingangConstants.MESSAGE_KEY_ERGEBNISEINGABESTUFE_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(ergebniseingangsart, this, ErgebniseingangConstants.MESSAGE_KEY_ERGEBNISEINGANGSART_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(ergebniseingangsfehlerstatus, this, ErgebniseingangConstants.MESSAGE_KEY_ERGEBNISEINGANGSFEHLERSTATUS_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(ergebniseingangsherkunft, this, ErgebniseingangConstants.MESSAGE_KEY_ERGEBNISEINGANGSHERKUNFT_EINZAHL, validationResult);
                                                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(ErgebniseingangConstants.ERGEBNISSEQUENZNUMMER_MAX_VALUE, ErgebniseingangConstants.ERGEBNISSEQUENZNUMMER_MIN_VALUE, ergebnissequenznummer, this, ErgebniseingangConstants.MESSAGE_KEY_ERGEBNISSEQUENZNUMMER_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(zeitstempel, this, ErgebniseingangConstants.MESSAGE_KEY_ZEITSTEMPEL_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
